unit uFrames;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Objects, FMX.Effects,
  FMX.Edit, FMX.Filter.Effects, FMX.Colors;

type
  TFrame1ButtonClicked = procedure (sender : TObject; var text : string) of Object;

type
  TfrmFrames = class(TForm)
    rec1: TRectangle;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    ShadowEffect1: TShadowEffect;
    Rec2: TRectangle;
    Label2: TLabel;
    ColorButton1: TColorButton;
    WaveEffect1: TWaveEffect;
    procedure Button1Click(Sender: TObject);
  private
    FFrame1ButtonClicked: TNotifyEvent;
    FOnFrame1ButtonClickedAdvanced: TFrame1ButtonClicked;
    procedure SetFrame1ButtonClicked(const Value: TNotifyEvent);
    procedure SetOnFrame1ButtonClickedAdvanced(
      const Value: TFrame1ButtonClicked);
    { Private declarations }
  public
    { Public declarations }
    property OnFrame1ButtonClicked : TNotifyEvent read FFrame1ButtonClicked write SetFrame1ButtonClicked;
    property OnFrame1ButtonClickedAdvanced :  TFrame1ButtonClicked read FOnFrame1ButtonClickedAdvanced write SetOnFrame1ButtonClickedAdvanced;
  end;



implementation

{$R *.fmx}

procedure TfrmFrames.Button1Click(Sender: TObject);
var s :string;
begin
   if assigned(FFrame1ButtonClicked) then
     FFrame1ButtonClicked(self);
   s := edit1.Text;
   if assigned(FOnFrame1ButtonClickedAdvanced) then
     FOnFrame1ButtonClickedAdvanced(self, s);
   edit1.Text := s;
end;

procedure TfrmFrames.SetFrame1ButtonClicked(const Value: TNotifyEvent);
begin
  FFrame1ButtonClicked := Value;
end;


procedure TfrmFrames.SetOnFrame1ButtonClickedAdvanced(
  const Value: TFrame1ButtonClicked);
begin
  FOnFrame1ButtonClickedAdvanced := Value;
end;

end.


